/*
 * @(#)java_lang_Thread.h
 *
 * (c) Copyright Sun Microsystems Inc, 1992-1999. All rights reserved.
 * (c) Copyright IBM Corporation, 1996-1999. All rights reserved.
 * 
 * This product is based in part on the work of the Independent JPEG group.
 * 
 * The Java(tm) technology is owned and exclusively licensed by 
 * Sun Microsystems Inc.  Java is a trademark of Sun Microsystems Inc. in
 * the U.S. and other countries.
 * 
 * US Govt Users Restricted Rights - Use duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
#include <native.h>
/* Header for class java_lang_Thread */

#ifndef _Included_java_lang_Thread
#define _Included_java_lang_Thread
struct Hjava_lang_Thread;
struct Hjava_lang_Runnable;
struct Hjava_lang_ThreadGroup;
struct Hjava_lang_Object;

#pragma pack(4)

typedef struct Classjava_lang_Thread {
    struct HArrayOfChar *name;
    long priority;
    struct Hjava_lang_Thread *threadQ;
    long PrivateInfo;
    long eetop;
    /*boolean*/ long single_step;
    /*boolean*/ long daemon;
    long status;
#undef java_lang_Thread_STOPPED
#define java_lang_Thread_STOPPED 1L
#undef java_lang_Thread_FINISHED
#define java_lang_Thread_FINISHED 2L
    struct Hjava_lang_Runnable *target;
/* Inaccessible static: activeThreadQ */
    struct Hjava_lang_ThreadGroup *group;
/* Inaccessible static: threadInitNumber */
    long initial_stack_memory;
    int64_t pThreadLocalStorage;
    struct Hjava_lang_Object *contextClassLoader;
    struct Hjava_lang_Object *inheritedAccessControlContext;
    struct Hjava_lang_Object *protectionContext;
#undef java_lang_Thread_MIN_PRIORITY
#define java_lang_Thread_MIN_PRIORITY 1L
#undef java_lang_Thread_NORM_PRIORITY
#define java_lang_Thread_NORM_PRIORITY 5L
#undef java_lang_Thread_MAX_PRIORITY
#define java_lang_Thread_MAX_PRIORITY 10L
} Classjava_lang_Thread;
HandleTo(java_lang_Thread);

#pragma pack()

#ifdef __cplusplus
extern "C" {
#endif
extern struct Hjava_lang_Thread *java_lang_Thread_currentThread(struct Hjava_lang_Thread *);
extern void java_lang_Thread_yield(struct Hjava_lang_Thread *);
extern void java_lang_Thread_sleep(struct Hjava_lang_Thread *,int64_t);
extern void java_lang_Thread_start(struct Hjava_lang_Thread *);
extern /*boolean*/ long java_lang_Thread_isInterrupted(struct Hjava_lang_Thread *,/*boolean*/ long);
extern /*boolean*/ long java_lang_Thread_isAlive(struct Hjava_lang_Thread *);
extern long java_lang_Thread_countStackFrames(struct Hjava_lang_Thread *);
extern void java_lang_Thread_setPriority0(struct Hjava_lang_Thread *,long);
extern void java_lang_Thread_stop0(struct Hjava_lang_Thread *,struct Hjava_lang_Object *);
extern void java_lang_Thread_suspend0(struct Hjava_lang_Thread *);
extern void java_lang_Thread_resume0(struct Hjava_lang_Thread *);
extern void java_lang_Thread_interrupt0(struct Hjava_lang_Thread *);
extern void java_lang_Thread_newThreadEvent0(struct Hjava_lang_Thread *,struct Hjava_lang_Thread *);
#ifdef __cplusplus
}
#endif
#endif
