/*
 * @(#)jcov.h
 *
 * (c) Copyright Sun Microsystems Inc, 1992-1999. All rights reserved.
 * (c) Copyright IBM Corporation, 1996-1999. All rights reserved.
 * 
 * This product is based in part on the work of the Independent JPEG group.
 * 
 * The Java(tm) technology is owned and exclusively licensed by 
 * Sun Microsystems Inc.  Java is a trademark of Sun Microsystems Inc. in
 * the U.S. and other countries.
 * 
 * US Govt Users Restricted Rights - Use duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
/*
 * @(#)jcov.h   1.2 96/12/17
 *
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 */

/*
 * Definitions for the Jcov     10/27/96
 * @author Leonid Arbouzov
 * leo@nbsp.nsk.su
 */

#ifndef _JCOV_H_
#define _JCOV_H_

extern char* testname;          /* Name of test */
extern char* cov_file;          /* Name of code coverage file */

#define CT_METHOD         1
#define CT_FIKT_METHOD    2
#define CT_BLOCK          3
#define CT_FIKT_RET       4
#define CT_CASE           5
#define CT_SWITH_WO_DEF   6
#define CT_BRANCH_TRUE    7
#define CT_BRANCH_FALSE   8

#if defined(IBM_MIXED_MODE)                                         /*ibm.6205*/
/* No JavaFrame for Mixed Mode, so accept methodblock directly */
extern void coverage_if(int flg, struct methodblock *mb, unsigned char *pc);
extern void coverage_switch(struct methodblock *mb, unsigned char *pc, int key, int low, int high);
extern void coverage_lookupswitch(struct methodblock *mb, unsigned char *pc, int npairs, int nodef);
#else  /* !IBM_MIXED_MODE */                                        /*ibm.6205*/
extern void coverage_if(int flg, JavaFrame *frame, unsigned char *pc);
extern void coverage_switch(JavaFrame *frame, unsigned char *pc, int key, int low, int high);
extern void coverage_lookupswitch(JavaFrame *frame, unsigned char *pc, int npairs, int nodef);
#endif /* !IBM_MIXED_MODE */                                        /*ibm.6205*/

extern void java_cov_dump();
extern int  jcov_write_data(char *);

#endif /* ! _JCOV_H_ */
