/*
 * atomic_md.h
 *
 * (c) Copyright Sun Microsystems Inc, 1992-1999. All rights reserved.
 * (c) Copyright IBM Corporation, 1996-1999. All rights reserved.
 * 
 * This product is based in part on the work of the Independent JPEG group.
 * 
 * The Java(tm) technology is owned and exclusively licensed by 
 * Sun Microsystems Inc.  Java is a trademark of Sun Microsystems Inc. in
 * the U.S. and other countries.
 * 
 * US Govt Users Restricted Rights - Use duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

#ifndef _AIX_ATOMIC_MD_H_
#define _AIX_ATOMIC_MD_H_

#ifndef IBM_LINUX
#include <sys/atomic_op.h>
#endif

typedef int atomic_t;		/* word type for atomic ops */
typedef int iatomic_t;		/* atomic word viewed as signed quantity */
typedef unsigned uatomic_t;	/* atomic word viewed as unsigned quantity */

#ifndef IBM_LINUX
#define COMPARE_AND_SWAP(addr, oldval_addr, newval) \
  compare_and_swap(addr, oldval_addr, newval)
#else
#define COMPARE_AND_SWAP(addr, oldval_addr, newval)       \
 ({ char result; int read_val;                            \
    __asm__ __volatile__("lock; cmpxchgl %3, %1; sete %0" \
        : "=q" (result), "=m" (*addr), "=a" (read_val)    \
        : "r" (newval), "m" (*addr), "a" (*oldval_addr)); \
    *oldval_addr = read_val;                              \
    result;                                               \
  })

/*
 PFE - 5/12/1999 - Kawachiya-san recommends above COMPARE_AND_SWAP
                   defn. from Chet/Watson Research 

  CmpAndSwap((*oldval_addr), (addr), (newval), (oldval_addr))

static __inline__ unsigned int CmpAndSwap(atomic_t oldval_addr, atomic_t *addr, atomic_t newval, atomic_t *ptr)
{
  
     unsigned int rc = 0;
     __asm__ __volatile__("mov %0, %%eax" : : "m" (oldval_addr) : "%eax" );
     __asm__ __volatile__("pushl %edx"                                   );
     __asm__ __volatile__("mov %0, %%edx" : : "m" (addr)        : "%edx" );
     __asm__ __volatile__("mov %0, %%ecx" : : "m" (newval)      : "%ecx" );
     __asm__ __volatile__("lock; cmpxchg %ecx, (%edx)"          );
     __asm__ __volatile__("popl %edx"                           );
     __asm__ __volatile__("movl $0, %eax"                       );
     __asm__ __volatile__("setz %al"                            );
     __asm__ __volatile__("mov %%eax, %0" : "=m" (rc)           );
     //match AIX impl. of compare_and_swap ...
     if (rc == 0)
     {
       *ptr = *addr;
     }
	 
     return rc;
  
}
*/

#endif /* IBM_LINUX */

#endif /* !_AIX_ATOMIC_MD_H_ */
