/*
 * src/unix/java/include/locale_str.h, a111, a111, a111-19970614 97/04/28
 *
 * (c) Copyright Sun Microsystems Inc, 1992-1999. All rights reserved.
 * (c) Copyright IBM Corporation, 1996-1999. All rights reserved.
 * 
 * This product is based in part on the work of the Independent JPEG group.
 * 
 * The Java(tm) technology is owned and exclusively licensed by 
 * Sun Microsystems Inc.  Java is a trademark of Sun Microsystems Inc. in
 * the U.S. and other countries.
 * 
 * US Govt Users Restricted Rights - Use duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/*
 * Mappings from partial locale names to full locale names
 */
static char *locale_aliases[] = {
    "ar", "ar_EG",
    "be", "be_BY",
    "bg", "bg_BG",
    "ca", "ca_ES",
    "cs", "cs_CZ",
    "cz", "cs_CZ",
    "da", "da_DK",
    "de", "de_DE",
    "el", "el_GR",
    "en", "en_US",
    "es", "es_ES",
    "et", "et_EE",
    "fi", "fi_FI",
    "fr", "fr_FR",
    "iw", "iw_IL",
    "hr", "hr_HR",
    "hu", "hu_HU",
    "is", "is_IS",
    "it", "it_IT",
    "ja", "ja_JP",
    "ko", "ko_KR",
    "lt", "lt_LT",
    "lv", "lv_LV",
    "mk", "mk_MK",
    "nl", "nl_NL",
    "no", "no_NO",
    "pl", "pl_PL",
    "pt", "pt_PT",
    "ro", "ro_RO",
    "ru", "ru_RU",
    "sh", "sh_YU",
    "sk", "sk_SK",
    "sl", "sl_SI",
    "sq", "sq_AL",
    "sr", "sr_YU",
    "su", "fi_FI",
    "sv", "sv_SE",
    "th", "th_TH",
    "tr", "tr_TR",
    "uk", "uk_UA",
    "zh", "zh_CN",
    "tchinese", "zh_TW",
    "big5", "zh_TW.Big5",
    ""
};

/*
 * AIX language string to ISO639 string mapping table.
 */
static char *language_names[] = {
    "C", "en",
    "POSIX", "en",
    "ar", "ar",
    "be", "be",
    "bg", "bg",
    "ca", "ca",
    "cs", "cs",		/* 1340: cz -> cs */
    "da", "da",
    "de", "de",
    "el", "el",
    "en", "en",
    "es", "es",
    "et", "et",
    "fi", "fi",
    "su", "fi",
    "fr", "fr",
    "he", "iw",
    "hr", "hr",
    "hu", "hu",
    "is", "is",
    "it", "it",
    "ja", "ja",
    "ko", "ko",
    "lt", "lt",
    "lv", "lv",
    "mk", "mk",
    "nl", "nl",
    "no", "no",
    "pl", "pl",
    "pt", "pt",
    "ro", "ro",
    "ru", "ru",
    "sh", "sh",
    "sk", "sk",
    "sl", "sl",
    "sq", "sq",
    "sr", "sr",
    "sv", "sv",
    "tr", "tr",
    "th", "th",
    "uk", "uk",
    "zh", "zh",
    "",
};

/*
 * AIX country string to ISO3166 string mapping table.
 */
static char *region_names[] = {
    "AT", "AT",
    "AU", "AU",
    "AR", "AR",
    "BE", "BE",
    "BR", "BR",
    "BO", "BO",
    "CA", "CA",
    "CH", "CH",
    "CL", "CL",
    "CN", "CN",
    "CO", "CO",
    "CR", "CR",
    "EC", "EC",
    "GT", "GT",
    "IE", "IE",
    "IL", "IL",
    "JP", "JP",
    "KR", "KR",
    "MX", "MX",
    "NI", "NI",
    "NZ", "NZ",
    "PA", "PA",
    "PE", "PE",
    "PY", "PY",
    "SV", "SV",
    "TH", "TH",
    "GB", "GB",
    "US", "US",
    "UY", "UY",
    "VE", "VE",
    "TW", "TW",
    "",
};

/*
 * AIX locale string to Encoding converter name mapping table.
 * default file.encoding is "8859_1".
 */
static char *encoding_names[] = {
    "8859-15", "ISO8859_15_FDIS",
    "iso8859-15", "ISO8859_15_FDIS",
    "ISO8859-15", "ISO8859_15_FDIS",
    "IBM-1252", "Cp1252",
    "IBM-932", "Cp942C", /* ibm.8711, ibm.11902 */
    "IBM-943", "Cp943C", /* ibm.8711, ibm.11902 */
    "AR_AA", "UTF8",
    "BE_BY", "UTF8",
    "BG_BG", "UTF8",
    "CA_ES", "UTF8",
    "CS_CZ", "UTF8",
    "DA_DK", "UTF8",
    "DE_CH", "UTF8",
    "DE_DE", "UTF8",
    "EL_GR", "UTF8",
    "EN_GB", "UTF8",
    "EN_US", "UTF8",
    "ES_ES", "UTF8",
    "ET_EE", "UTF8",
    "FI_FI", "UTF8",
    "FR_BE", "UTF8",
    "FR_CA", "UTF8",
    "FR_CH", "UTF8",
    "FR_FR", "UTF8",
    "HE_IL", "UTF8",
    "HR_HR", "UTF8",
    "HU_HU", "UTF8",
    "IS_IS", "UTF8",
    "IT_IT", "UTF8",
    "JA_JP", "UTF8",
    "KO_KR", "UTF8",
    "LT_LT", "UTF8",
    "LV_LV", "UTF8",
    "MK_MK", "UTF8",
    "NL_BE", "UTF8",
    "NL_NL", "UTF8",
    "NO_NO", "UTF8",
    "PL_PL", "UTF8",
    "PT_BR", "UTF8",
    "PT_PT", "UTF8",
    "RO_RO", "UTF8",
    "RU_RU", "UTF8",
    "SH_SP", "UTF8",
    "SK_SK", "UTF8",
    "SL_SI", "UTF8",
    "SQ_AL", "UTF8",
    "SR_SP", "UTF8",
    "SV_SE", "UTF8",
    "TH_TH", "UTF8",
    "TR_TR", "UTF8",
    "UK_UA", "UTF8",
    "VI_VN", "UTF8",
    "ZH_CN", "UTF8",
    "ZH_TW", "UTF8",
    "ar", "Cp1046",        /* ibm.5240: problems with 8859_6 */
    "be", "ISO8859_5",
    "bg", "ISO8859_5",
    "cs", "ISO8859_2",		/* 1340: cz -> cs */
    "el", "ISO8859_7",
    "iw", "ISO8859_8",
    "hr", "ISO8859_2",
    "hu", "ISO8859_2",
    "iw", "ISO8859_8",
    "ja", "EUC_JP",
    "japanese", "EUC_JP",
    "Ja", "SJIS",
    "Ja_JP", "Cp942C",     /* ibm.11902 */
    "ja_JP", "Cp33722C",   /* ibm.11902 */
    "ko", "KSC5601",
    "lt", "ISO8859_4",
    "lv", "ISO8859_4",
    "mk", "ISO8859_5",
    "pl", "ISO8859_2",
    "ro", "ISO8859_2",
    "ru", "ISO8859_5",
    "sh", "ISO8859_2",
    "sk", "ISO8859_2",
    "sl", "ISO8859_2",
    "sq", "ISO8859_1",     /* ibm.6572 */
    "sr", "ISO8859_5",
    "tr", "ISO8859_9",
    "uk", "ISO8859_5",
    "th", "TIS620",
    "GBK", "GBK", 
    "zh", "GB2312",
    "Zh", "GBK",
    "ZH", "UTF8",
    "zh_TW", "CNS11643",
    "Zh_TW", "Big5",
    "BIG5", "Big5",
    "KOI8", "Koi8",
    "Ar", "Cp1046",
    "Ca", "Cp850",
    "Da", "Cp850",
    "Nl", "Cp850",
    "En", "Cp850",
    "Es", "Cp850",
    "Et", "Cp922",
    "ET", "UTF8",
    "Fi", "Cp850",
    "Fr", "Cp850",
    "De", "Cp850",
    "Is", "Cp850",
    "It", "Cp850",
    "Iw", "Cp856",
    "Lt", "Cp921",
    "LT", "UTF8",
    "Lv", "Cp921",
    "LV", "UTF8",
    "No", "Cp850",
    "Pt", "Cp850",
    "Sv", "Cp850",
    "Uk", "Cp1124",
    "",
};

/*
 * IBM02128: AIX to Java time zone name mapping.
 *   Starting from GMT and heading west.
 */
static char *timezone_names[] = {

/* Half-hour time zones listed first so the number will always override any name.
 * This is because AIX does not specify a name for these zones. */
    "+3.5",     "CNT",  /* Canada Newfoundland Time */
    "-9.5",     "ACT",  /* Australian Central Time */
    "-5.5",     "IST",  /* India Standard Time */
    "-3.5",     "MET",  /* Middle Eastern Time */

/* If the user uses the Java name for a half hour time zone, then
** use this before the number. */
    "CNT",      "CNT",  /* In case user uses Java name */
    "ACT",      "ACT",  /* In case user uses Java name */
    "IST",      "IST",  /* In case user uses Java name */
    "MET",      "MET",  /* In case user uses Java name */

/* Resolve standard AIX name to Java name */
    "CUT",      "GMT",	/* "GMT" is the closest equivalent to AIX's "CUT" -
                        ** Java has no time zone +0 without daylight savings */
    "AZOREST",  "CAT",  /* Central African Time */
 /* "FALKST",   "???",  ** Falkland Islands: No Java equivalent */
    "GRNLNDST_","AGT",  /* If there's no summer Time, then use Argentina Time */
    "GRNLNDST", "BET",  /* If there is summar time, then use Brazilan Eastern Time */
    "AGT",      "AGT",  /* In case user uses Java name */
    "AST",      "PRT",  /* Brazilian Central Time -> Puerto Rico Time ??? */
    "EST_",     "IET",  /* Indiana Eastern Standard Time */
    "IET",      "IET",  /* In case user uses java name: Indiana Eastern Standard Time */
    "EST",      "EST",  /* Eastern Standard Time */
    "CST",      "CST",  /* Central Standard Time */
    "MST_",     "PNT",  /* Mountain Standard Time with no daylight savings becomes
                        ** Phoenix Standard Time */
    "PNT",      "PNT",  /* In case user uses Java name: Phoenix Standard Time */
    "MST",      "MST",  /* Mountain Standard Time */
    "PST",      "PST",  /* Pacific Standard Time */
    "AST",      "AST",  /* Alaska Standard Time */
    "HST",      "HST",  /* Hawaii Standard Time */
    "BST",      "MIT",  /* Bering Strait -> Midway Islands Time */
    "NZST",     "NST",  /* New Zealand Standard Time */
    "MET",      "SST",  /* Solomon Standard Time */
    "AET",      "AET",  /* Australian Eastern Time */ /* ibm.11842 */
    "KORST",    "JST",  /* Korean Standard Time -> Japan Standard Time */
    "WAUST",    "CTT",  /* Western Australia -> China Taiwan Time */
    "TAIST",    "CTT",  /* Taiwan -> China Taiwan Time */
    "THAIST",   "VST",  /* Thailand -> Vietnam Standard Time */
    "TASHST",   "BST",  /* Central Asia -> Bangladesh Standard Time */
    "PAKST",    "PLT",  /* Pakistan -> Pakistan Lahore Time */
    "WST",      "NET",  /* Gorki, Oman -> Near Eastern Time */
    "MEST",     "EAT",  /* Turkey -> East African Time */
    "SAUST",    "EAT",  /* Saudi Arabia -> East African Time */
    "WET",      "EET",  /* Finland -> Eastern European Time ??? */
    "USAST",    "ART",  /* South Africa -> Egyptian Standard Time ??? */
    "NFT",      "ECT",  /* Norway -> European Central Time */

/* If the name cannot be resolved, work the time zone out from the
** number. */
    "+0",       "GMT",  /* Greenwich Mean Time */
    "+1",       "CAT",  /* Central African Time */
    "+3",       "AGT",  /* Argentina Time */
    "+4",       "PRT",  /* Purerto Rico Time */
    "+5",       "EST",  /* Eastern Standard Time */
    "+6",       "CST",  /* Central Standard Time */
    "+7",       "MST",  /* Mountain Standard Time */
    "+8",       "PST",  /* Pacific Standard Time */
    "+9",       "AST",  /* Alaska Standard Time */
    "+10",      "HST",  /* Hawaii Standard Time */
    "+11",      "MIT",  /* Midway Islands Time */
    "-12",      "NST",  /* New Zealand Standard Time */
    "-11",      "SST",  /* Solomon Standard Time */
    "-10",      "AET",  /* Australian Eastern Time */
    "-9",       "JST",  /* Japan Standard Time */
    "-8",       "CTT",  /* China Taiwan Time */
    "-7",       "VST",  /* Vietnam Standard Time */
    "-6",       "BST",  /* Bangladesh Standard Time */
    "-5",       "PLT",  /* Pakistan Lahore Time */
    "-4",       "NET",  /* Near Eastern Time */
    "-3",       "EAT",  /* East African Time */
    "-2",       "EET",  /* Eastern European Time */
    "-1",       "ECT",  /* European Central Time */
    "",
};

/* ibm.5181
 * AIX variant string to Java variant name mapping table.
 */
static char *variant_names[] = {
    "euro", "EURO",
    "",
};
