/*
 * src/unix/java/native_threads/include/monitor_md.h, aix, a110, a110-19970404 97/03/11
 *
 * (c) Copyright Sun Microsystems Inc, 1992-1999. All rights reserved.
 * (c) Copyright IBM Corporation, 1996-1999. All rights reserved.
 * 
 * This product is based in part on the work of the Independent JPEG group.
 * 
 * The Java(tm) technology is owned and exclusively licensed by 
 * Sun Microsystems Inc.  Java is a trademark of Sun Microsystems Inc. in
 * the U.S. and other countries.
 * 
 * US Govt Users Restricted Rights - Use duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

#ifndef POSIX_MONITOR_MD_H
#define POSIX_MONITOR_MD_H

#define SYS_MON_IN_CACHE	0x10
#define SYS_MON_IN_USE		0x01


#include	<pthread.h>

struct wait_record_header {
  volatile struct wait_record_header* next;
  volatile struct wait_record_header* prev;
};

struct wait_record {
  struct wait_record_header hdr;
  struct sys_thread*    waitThread; /* ibm.5487 */
};

struct sys_mon {
  volatile pthread_t monitor_owner; /* ibm.5487 */
  volatile int entrycount; /* ibm.5487 */
	/*  volatile int mutexLock; ibm.5487, 6232 */
	volatile pthread_mutex_t gate;
  volatile struct sys_thread *lockQueue; /* ibm.5487 */
  struct wait_record_header wait;	/* Linked list of waiting threads */
};

void init_java_mutex_and_cond_attrs();

/* ibm.3917 */
typedef struct {
  int UseFastMon;
  void *p_monitorEnterQuicker;
  void *p_monitorExitQuicker;
  void *p_sysMonitorEnterFromAsm;
  void *p_sysMonitorExitFromAsm;
  void *p_monitorIntegerEnter; /* in monitor.c */
  void *p_monitorIntegerExit;   /* in monitor.c */
} MonFlatLinkVector;

extern MonFlatLinkVector p_MonFlatLinkVector;
/* ibm.3917 - end */

#endif
