/*
 * @(#)mutex_md.h	1.6 96/11/23
 *
 * (c) Copyright Sun Microsystems Inc, 1992-1999. All rights reserved.
 * (c) Copyright IBM Corporation, 1996-1999. All rights reserved.
 * 
 * This product is based in part on the work of the Independent JPEG group.
 * 
 * The Java(tm) technology is owned and exclusively licensed by 
 * Sun Microsystems Inc.  Java is a trademark of Sun Microsystems Inc. in
 * the U.S. and other countries.
 * 
 * US Govt Users Restricted Rights - Use duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/*
 * Interface to mutex HPI implementation for Solaris
 */

#ifndef _MUTEX_MD_H_
#define _MUTEX_MD_H_

#include <synch.h>

/*
 * Generally, we would typedef mutex_t to be whatever the system
 * supplies.  But Solaris gives us mutex_t directly.
 */

int    mutexInit(mutex_t *);
int    mutexDestroy(mutex_t *);
int    mutexLock(mutex_t *);
bool_t mutexLocked(mutex_t *);
int    mutexUnlock(mutex_t *);

#endif /* !_MUTEX_MD_H_ */
