/*
 * @(#)signalerrorno.h  1.1 97/02/10
 *
 * (c) Copyright Sun Microsystems Inc, 1992-1999. All rights reserved.
 * (c) Copyright IBM Corporation, 1996-1999. All rights reserved.
 * 
 * This product is based in part on the work of the Independent JPEG group.
 * 
 * The Java(tm) technology is owned and exclusively licensed by 
 * Sun Microsystems Inc.  Java is a trademark of Sun Microsystems Inc. in
 * the U.S. and other countries.
 * 
 * US Govt Users Restricted Rights - Use duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

#ifndef _AIX_SIGNALERRORNO_H_
#define _AIX_SIGNALERRORNO_H_

#include "sysmacros_md.h"

#ifdef IBM_LINUX /* kawatiya 1999/08/10 */
/*
 * Unlike AIX, Linux (glibc) strerror_r() directly returns error string.
 * The provided buf is *not* always filled in.
 *						kawatiya 1999/08/10
 */
#define SignalErrorNo(one, two) \
  { \
    char buf[129]; \
    SignalError(one, two, strerror_r(errno, buf, 128)); \
  }
#else /* Original code of AIX */
#define SignalErrorNo(one, two) \
  { \
    char error_msg[129]; \
    forbid(); \
    strerror_r(errno, error_msg, 128); \
    permit(); \
    SignalError(one, two, error_msg); \
  }
#endif

#endif

