/*
 * @(#)mmi.h
 *
 * (c) Copyright Sun Microsystems Inc, 1992-1999. All rights reserved.
 * (c) Copyright IBM Corporation, 1996-1999. All rights reserved.
 * 
 * This product is based in part on the work of the Independent JPEG group.
 * 
 * The Java(tm) technology is owned and exclusively licensed by 
 * Sun Microsystems Inc.  Java is a trademark of Sun Microsystems Inc. in
 * the U.S. and other countries.
 * 
 * US Govt Users Restricted Rights - Use duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
/* @(#) 05 1.1  src/share/java/include/mmi.h, l118, l118, l118-20010109 7/30/99 13:20:13 */
/*
 *   COMPONENT_NAME: 
 *
 *   FUNCTIONS: 
 *
 *   ORIGINS: 27
 *
 *   (C) COPYRIGHT International Business Machines Corp. 1998
 *   All Rights Reserved
 *   US Government Users Restricted Rights - Use, duplication or
 *   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

#ifndef __MMI_H__
#define __MMI_H__

#ifdef IBM_MIXED_MODE
/*===========================================================================
 mmi.h : Definitions shared with JIT
===========================================================================*/
#if !defined(JMS_TRL) || defined(USE_JAVASTACK)
#error JAVA STACK version is not supported by MMI
#endif /* !JMS_TRL || USE_JAVASTACK */

/*===========================================================================
 General Parameters
===========================================================================*/


/*---------------------------------------------------------------------------
 Basic types in JIT
---------------------------------------------------------------------------*/
#ifndef _GENCODE_STRUCT_H  /*-- if not defined yet --*/
#if defined(IBM_AIX)
typedef  unsigned int    CODEPTR_TYPE;
typedef  unsigned int   *CODEPTR;
typedef  unsigned long   ADDR_TYPE;
typedef  unsigned long  *ADDR;
#elif defined(IBM_INTEL)
typedef  unsigned char   CODEPTR_TYPE;
typedef  unsigned char  *CODEPTR;
typedef  unsigned long   ADDR_TYPE;
typedef  unsigned char  *ADDR;
#endif

typedef struct codeattribute  *CattrT;
#endif /* _GENCODE_STRUCT_H */

/*---------------------------------------------------------------------------
 Basic macros shared with JIT
---------------------------------------------------------------------------*/
#ifndef JIT_CATCHFRAME
#define JIT_CATCHFRAME(mb)	((mb->exception_table)->compiled_CatchFrame)
#endif /* JIT_CATCHFRAME */

/*---------------------------------------------------------------------------
 Return value to control MMI2JIT Transfer at loop backedge
---------------------------------------------------------------------------*/
#define  LOOPCOUNT_TINY     ((unsigned int)0)
#define  LOOPCOUNT_SMALL    ((unsigned int)1)
#define  LOOPCOUNT_UNKNOWN  ((unsigned int)2)
#define  LOOPCOUNT_TOOMANY  ((unsigned int)0xffffffff)

#ifdef MMI2JIT_TRANSFER
/*---------------------------------------------------------------------------
 structures for MMI2JIT Transfer
---------------------------------------------------------------------------*/
#ifndef _JIT_STRUCT_H  /*-- if not defined yet --*/
typedef struct bbattribute	BBattrT;
struct transfer_point_entry_information
{
    void *				bwd_jump_address;	/* bytecode address of bwd jump inst. */
    BBattrT *				bwdj_bbattr;		/* bb index of transfer point. */
    BBattrT *				tp_bbattr;		/* bb index of transfer point. */
    CODEPTR				entry_code_address;	/* code address called by MMI. */
    int					n_code;			/* number of ext-bytecode executed before transfer point. */
    CattrT *				ca_table;		/* ext-bytecode table executed before transfer point. */
    long				try_region_no;		/* try region number of transfer point. */
};
typedef struct transfer_point_entry_information	TPentryT;

#define	bwdj_addr_tpentry(tpentry)	((tpentry)->bwd_jump_address)
#define	bwdj_bbattr_tpentry(tpentry)	((tpentry)->bwdj_bbattr)
#define	tp_bbattr_tpentry(tpentry)	((tpentry)->tp_bbattr)
#define	entry_addr_tpentry(tpentry)	((tpentry)->entry_code_address)
#define	ncode_tpentry(tpentry)		((tpentry)->n_code)
#define	code_tpentry(tpentry)		((tpentry)->ca_table)
#define	tryno_tpentry(tpentry)		((tpentry)->try_region_no)
#endif /* _JIT_STRUCT_H */

#endif /* MMI2JIT_TRANSFER */

/*===========================================================================
 End of Definitions
===========================================================================*/
#endif /* IBM_MIXED_MODE */
#endif /* __MMI_H__ */
