/*
 * src/share/java/include/sys_events.h, s116, s116 1998/12/16
 *
 * (c) Copyright Sun Microsystems Inc, 1992-1999. All rights reserved.
 * (c) Copyright IBM Corporation, 1996-1999. All rights reserved.
 * 
 * This product is based in part on the work of the Independent JPEG group.
 * 
 * The Java(tm) technology is owned and exclusively licensed by 
 * Sun Microsystems Inc.  Java is a trademark of Sun Microsystems Inc. in
 * the U.S. and other countries.
 * 
 * US Govt Users Restricted Rights - Use duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/*
 * Java Virtual Machine Event Interface (JVMEI)
 */

#ifndef _SYS_EVENTS_MD_H
#define _SYS_EVENTS_MD_H

#include "events.h"

extern int jvmei_active;

struct sysHandler {
    jtoken handlerToken;
    void   *pHandlerGlobalStorage;
    void   (*pEventHandler)(JVMEI_Event_t *pEventData);
    char   eventsEnabled[JVMEI_EVENT_MAX+1];
};
typedef struct sysHandler sysHandler_t;

struct JVMEI_Vector {
    sysHandler_t *pSysHandler;
    void *(*pSysGetThreadLocalStorage)(jtoken handlerToken,
                                       jtoken threadToken);
    jint (*pSysSetThreadLocalStorage)(jtoken handlerToken,
                                      jtoken threadToken,
                                      void *pThreadStorage);
    void (*pSysNotifyEvent)(jtoken eventToken,
                            jint eventType,
                            void *pEventData);
};
typedef struct JVMEI_Vector JVMEI_Vector_t;

void JEI_InitializeEvents(JVMEI_Vector_t *jvmei_vectors);

#endif /* !SYS__EVENTS_MD_H */
